#ifndef GESTURE_DRAWER_H
#define GESTURE_DRAWER_H

#include <qframe.h>
#include <qstring.h>
#include <qevent.h>
#include <qpoint.h>
#include <qwidget.h>
#include <qsize.h>

namespace KHotKeys {

class GestureDrawer : public QFrame
  {
    public:
  GestureDrawer(QWidget *parent, const char *name);
  ~GestureDrawer();

  void setData(const QString &data);

  QSize sizeHint() { return QSize(30, 30); }
  
    protected:
  void paintEvent(QPaintEvent *ev);
  
    private:
  QPoint lookupCellCoords(Q_UINT32 cell);
  void drawArrowHead(QPoint &start, QPoint &end,
		     QPainter &p);
  
  
  QString _data;
  };

} // end namespace

#endif
