#ifndef GESTURE_H
#define GESTURE_H

#include <qobject.h>
#include <qtimer.h>

#include <X11/Xlib.h>

#include "stroke.h"

namespace KHotKeys {
    
class Gesture : public QObject
    {
        Q_OBJECT
        
    public:
    Gesture( bool enable_signals_P, QObject* parent_P );
    virtual ~Gesture();
  
    protected slots:
    void slotMousePollTimeout();
  
    signals:
    void handle_gesture(const QString &gesture);
    
    private:
    void initXCon();
    
    bool _enable_signals;

    Display *_display;
    Window _root, _rootIDRet, _childIDRet;
    int _winX, _winY;
    unsigned int _stateMask;
    int _xCoord, _yCoord;
  
    QPoint _lastGridCoord;
    int _mousePaused;
  
    char _sequence[MAX_SEQUENCE+1];
  
    Q_UINT32 _numStrokesRecorded;
    Q_UINT32 _lifeLength;
  
    QTimer _mousePollTimer;
    };
    
} // end namespace KHotKeys


#endif

